package org.dromara.web.service.impl;

import cn.hutool.core.collection.CollUtil;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.fasterxml.jackson.databind.ObjectMapper;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.dromara.common.mybatis.core.page.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.system.domain.bo.SysScreeningAssessmentConfigBo;
import org.dromara.web.domain.ChargeSet;
import org.dromara.web.domain.bo.ChargeSetBo;
import org.dromara.web.domain.vo.ChargeItemVo;
import org.dromara.web.domain.vo.ChargeSetVo;
import org.dromara.web.mapper.ChargeSetMapper;
import org.dromara.web.service.IChargeSetService;
import org.springframework.stereotype.Service;


import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 收费设置Service业务层处理
 *
 * @author Lion Li
 * @date 2025-08-04
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class ChargeSetServiceImpl implements IChargeSetService {

    private final ChargeSetMapper baseMapper;

    /**
     * 查询收费设置
     *
     * @param chargeId 主键
     * @return 收费设置
     */
    @Override
    public ChargeSetVo queryById(Long chargeId) {
        return baseMapper.selectVoById(chargeId);
    }

    /**
     * 分页查询收费设置列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 收费设置分页列表
     */
    @Override
    public TableDataInfo<ChargeSetVo> queryPageList(ChargeSetBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<ChargeSet> lqw = buildQueryWrapper(bo);
        Page<ChargeSetVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        List<ChargeSetVo> records = result.getRecords();
        if (CollUtil.isNotEmpty(records)) {
            records.forEach(v -> {
                v.setChargeItemArr(JSON.parseArray(v.getOneWayCharge(), ChargeItemVo.class));
            });
        }
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的收费设置列表
     *
     * @param bo 查询条件
     * @return 收费设置列表
     */
    @Override
    public List<ChargeSetVo> queryList(ChargeSetBo bo) {
        LambdaQueryWrapper<ChargeSet> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<ChargeSet> buildQueryWrapper(ChargeSetBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<ChargeSet> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(ChargeSet::getChargeId);

        return lqw;
    }

    /**
     * 新增收费设置
     *
     * @param bo 收费设置
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(ChargeSetBo bo) {
        List<ChargeItemVo> itemVoList = bo.getChargeItemArr();
        String itemVoListStr = JSON.toJSONString(itemVoList);
        bo.setOneWayCharge(itemVoListStr);
        ChargeSet add = MapstructUtils.convert(bo, ChargeSet.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setChargeId(add.getChargeId());
        }
        return flag;
    }

    /**
     * 修改收费设置
     *
     * @param bo 收费设置
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(ChargeSetBo bo) {
        List<ChargeItemVo> itemVoList = bo.getChargeItemArr();
        String itemVoListStr = JSON.toJSONString(itemVoList);
        bo.setOneWayCharge(itemVoListStr);
        ChargeSet update = MapstructUtils.convert(bo, ChargeSet.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(ChargeSet entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除收费设置信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
